---
title: FileSystemDirectoryReader
slug: Web/API/FileSystemDirectoryReader
tags:
  - API
  - File System API
  - File and Directory Entries API
  - FileSystemDirectoryReader
  - Files
  - Interface
  - Non-standard
  - Offline
  - Reference
---
<p>{{APIRef("File System API")}}{{Non-standard_header}}</p>

<p>The <code>FileSystemDirectoryReader</code> interface of the <a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a> lets you access the {{domxref("FileEntry")}}-based objects (generally {{domxref("FileSystemFileEntry")}} or {{domxref("FileSystemDirectoryEntry")}}) representing each entry in a directory.</p>

<div class="note">
<p>Because this is a non-standard API, whose specification is not currently on a standards track, it's important to keep in mind that not all browsers implement it, and those that do may implement only small portions of it. Check the {{anch("Browser compatibility")}} section for details.</p>
</div>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref("FileSystemDirectoryReader.readEntries", "readEntries()")}}</dt>
	<dd>Returns an array containing some number of the directory's entries. Each item in the array is an object based on {{domxref("FileSystemEntry")}}—typically either {{domxref("FileSystemFileEntry")}} or {{domxref("FileSystemDirectoryEntry")}}.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('File System API')}}</td>
			<td>{{Spec2('File System API')}}</td>
			<td>Draft of proposed API</td>
		</tr>
	</tbody>
</table>

<p>This API has no official W3C or WHATWG specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemDirectoryReader")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
	<li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
	<li>{{domxref("FileSystemDirectoryEntry")}}</li>
	<li>{{domxref("FileSystem")}}</li>
</ul>
